﻿using System;
using System.Windows.Media;
using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;

namespace GreenDot
{
    public class Main : CombatRoutine
    {
        public override string Name
        {
            get { return "Pica's Warlock PvP Combat Routine [Free Edition]"; }
        }

        public override WoWClass Class
        {
            get { return WoWClass.Warlock; }
        }

        public override bool WantButton { get { return true; } }

        public override void OnButtonPress()
        {
            if (StyxWoW.Me.Specialization == WoWSpec.WarlockDemonology) Logging.Write(Colors.Red, string.Format("[CC] Coming next, donation for more motivation!"));
            if (StyxWoW.Me.Specialization == WoWSpec.WarlockAffliction) new Affli.frmForm().ShowDialog();
            if (StyxWoW.Me.Specialization == WoWSpec.WarlockDestruction) Logging.Write(Colors.Red, string.Format("[CC] Coming next, donation for more motivation!"));
        }

        public override Composite PreCombatBuffBehavior
        {
            get
            {
                if (StyxWoW.Me.Specialization == WoWSpec.WarlockDestruction) return new ActionRunCoroutine(arc => Destro.Rotations.PreCombatBuffRoutine());
                if (StyxWoW.Me.Specialization == WoWSpec.WarlockDemonology) return new ActionRunCoroutine(arc => Affli.Rotations.PreCombatBuffRoutine());

                // Default
                return new ActionRunCoroutine( arc => Affli.Rotations.PreCombatBuffRoutine());
            }
        }

        public override Composite PullBehavior
        {
            get
            {
                if(StyxWoW.Me.Specialization == WoWSpec.WarlockDestruction) return new ActionRunCoroutine(arc => Destro.Rotations.PullRoutine());
                if (StyxWoW.Me.Specialization == WoWSpec.WarlockDemonology) return new ActionRunCoroutine(arc => Demo.Rotations.PullRoutine());

                // Default
                return new ActionRunCoroutine(arc => Affli.Rotations.PullRoutine());
            }
        }

        public override Composite CombatBehavior
        {
            get
            {
                if (StyxWoW.Me.Specialization == WoWSpec.WarlockDestruction) return new ActionRunCoroutine(arc => Destro.Rotations.CombatRoutine());
                if (StyxWoW.Me.Specialization == WoWSpec.WarlockDemonology) return new ActionRunCoroutine(arc => Demo.Rotations.CombatRoutine());

                // Default
                return new ActionRunCoroutine(arc => Affli.Rotations.CombatRoutine());
            }
        }
    }
}